--[[
Author: Lazy E Modding, Mantrid
https://www.lazyemodding.com
https://fs.mantrid.net/

Copyright: Ask Premission 
]]

-- A little local function to kick off our mod
local function initMod(modDirectory)
	source(Utils.getFilename("scripts/BaleTextureChanger.lua", modDirectory))
	source(Utils.getFilename("scripts/gui/BaleTextureChangerMenu.lua", modDirectory))

	-- Set some hooks in, so the game calls us when needed
	Bale.setFillType = Utils.prependedFunction(Bale.setFillType, BaleTextureChanger.before_setFillType) -- Before the bale fill type is set, we want to switch out the texture
	FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, BaleTextureChanger.registerActionEvents) -- For our hotkey to be registered
	FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, BaleTextureChanger.saveSettings) -- Save settings when the game does
    Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, function(mission)
		BaleTextureChanger:loadSettings() -- Loads our saved settings
	end)

	-- Load and register our menu
	g_baleTextureChangerMenu = BaleTextureChangerMenu.new()
	g_gui:loadProfiles(Utils.getFilename("gui/guiProfiles.xml", modDirectory))
	g_gui:loadGui(Utils.getFilename("gui/BaleTextureChangerMenu.xml", modDirectory), "BaleTextureChangerMenu", g_baleTextureChangerMenu)
end

-- Run the function, passing through the global variable that says where we're located on disk
initMod(g_currentModDirectory)
